<?xml version="1.0"?>
<!--
	The lestes compiler suite
	Copyright (C) 2002, 2003, 2004, 2005 Miroslav Tichy
	Copyright (C) 2002, 2003, 2004, 2005 Petr Zika
	Copyright (C) 2002, 2003, 2004, 2005 Vojtech Hala
	Copyright (C) 2002, 2003, 2004, 2005 Jiri Kosina
	Copyright (C) 2002, 2003, 2004, 2005 Pavel Sanda
	Copyright (C) 2002, 2003, 2004, 2005 Jan Zouhar
	Copyright (C) 2002, 2003, 2004, 2005 Rudolf Thomas

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; version 2 of the License.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	See the full text of the GNU General Public License version 2, and
	the limitations in the file doc/LICENSE.

	By accepting the license the licensee waives any and all claims
	against the copyright holder(s) related in whole or in part to the
	work, its use, and/or the inability to use it.
-->
<!DOCTYPE xsl:transform [
	<!ENTITY nl "&#x0A;">
	<!ENTITY tab "&#x09;">
]>
<xsl:transform version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:lmd="http://lestes.jikos.cz/schemas/lmd"
 xmlns:h="http://www.w3.org/TR/REC-html40">
	<!-- Generate declarations of messages. -->
	<xsl:output method="text" encoding="ISO-8859-1"/>

	<xsl:template match="/lmd:lmd">
		<xsl:text>// This file is automatically generated, do not edit.&nl;</xsl:text>
		<xsl:apply-templates select="lmd:file-name" />
		<xsl:apply-templates select="lmd:dox[@file!='cc']" mode="file" />
		<xsl:text>#include &lt;lestes/common.hh&gt;&nl;</xsl:text>
		<xsl:text>#include &lt;lestes/msg/reporting_support.hh&gt;&nl;</xsl:text>
		<xsl:apply-templates select="lmd:imports" />
		<xsl:apply-templates select="lmd:foreign-class" />
		<xsl:apply-templates select="lmd:packages" mode="begin" />
      <xsl:apply-templates select="lmd:fatal | lmd:error | lmd:warning" />
		<xsl:apply-templates select="lmd:packages" mode="end"/>
		<xsl:text>#endif&nl;</xsl:text>
	</xsl:template>

	<xsl:template match="lmd:imports">
		<xsl:apply-templates select="lmd:i"/>
		<xsl:text>&nl;</xsl:text>
	</xsl:template>
	 
	<xsl:template match="lmd:i">
		<xsl:value-of select="concat('#include &lt;',./text(),'&gt;&nl;')"/>
	</xsl:template>
	 
	<xsl:template match="lmd:packages" mode="begin">
		<xsl:apply-templates select="lmd:p" mode="begin" />
	</xsl:template>
	
	<xsl:template match="lmd:p" mode="begin">
		<xsl:value-of select="concat('package(',.,');&nl;')" />
	</xsl:template>

	<xsl:template match="lmd:packages" mode="end">
		<xsl:apply-templates select="lmd:p" mode="end">
			<xsl:sort select="position()" date-type="number" order="descending" />
		</xsl:apply-templates>
	</xsl:template>
	
	<xsl:template match="lmd:p" mode="end">
		<xsl:value-of select="concat('end_package(',.,');&nl;')" />
	</xsl:template>

	<xsl:template match="lmd:foreign-class">
      <xsl:apply-templates select="lmd:p" mode="begin" />
		<xsl:value-of select="concat('class ',@name,';&nl;')" />
		<xsl:apply-templates select="lmd:p" mode="end">
			<xsl:sort select="position()" date-type="number" order="descending" />
		</xsl:apply-templates>
		<xsl:text>&nl;</xsl:text>
	</xsl:template>
	
	<xsl:template match="lmd:packages" mode="macro">
		<xsl:apply-templates select="lmd:p" mode="macro" />
	</xsl:template>
	
	<xsl:template match="lmd:p" mode="macro">
		<xsl:value-of select="concat(.,'__')" />
	</xsl:template>

	<xsl:template match="lmd:file-name">
		<xsl:variable name="guard">
			<xsl:apply-templates select="/lmd:lmd/lmd:packages" mode="macro" />
			<xsl:value-of select="translate(/lmd:lmd/lmd:file-name,'.','_')"/>
			<xsl:text>_m_hh__included</xsl:text>
		</xsl:variable>
		<xsl:value-of select="concat('&nl;#ifndef ',$guard,'&nl;')"/>
		<xsl:value-of select="concat('#define ',$guard,'&nl;')"/>
	</xsl:template>

	<xsl:template match="lmd:fatal | lmd:error | lmd:warning">
		<xsl:apply-templates select="lmd:dox"/>
		<xsl:text>extern ptr &lt; ::lestes::msg::message_stencil</xsl:text>
			<xsl:value-of select="count(lmd:param)"/>
		<xsl:text>&lt; </xsl:text>
		<xsl:choose>
			<xsl:when test="lmd:param">
				<xsl:apply-templates select="lmd:param" />
			</xsl:when>
			<xsl:otherwise>
			<xsl:text>bool</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:value-of select="concat(' &gt; &gt; ',@name,';&nl;')" />
	</xsl:template>

	<xsl:template match="lmd:dox" mode="file">
		<xsl:text>/*! \file&nl;</xsl:text>
		<xsl:text>\brief </xsl:text>
		<xsl:value-of select="normalize-space(lmd:bri)"/>
		<xsl:text>&nl;</xsl:text>
		<xsl:value-of select="lmd:det"/>
		<xsl:text>&nl;*/&nl;</xsl:text>
	</xsl:template>

	<xsl:template match="lmd:dox">
	<xsl:text>//! </xsl:text>
	<xsl:value-of select="normalize-space(lmd:bri)"/>
	<xsl:text>&nl;</xsl:text>
	</xsl:template>

	<xsl:template match="lmd:param">
		<xsl:if test="position() != 1">
			<xsl:text>, </xsl:text>
		</xsl:if>
		<xsl:value-of select="@type" />
	</xsl:template>

	<xsl:template match="*" />
</xsl:transform>
